// callback function
#pragma once

#include "mid811func.h"
#include "interfaces.h"

#define MAX_LASTFRAME_SIZE (768*576*4)

class CCallback: public ISampleGrabberCB
{
public:
    HANDLE  m_hFrameEvent;
    UCHAR   m_last_frame[MAX_LASTFRAME_SIZE];
    ULONG   m_last_size;
    CRITICAL_SECTION m_critSec;
	BOOL    m_bOn;
    CCallback() 
    {
        m_hFrameEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
        InitializeCriticalSection(&m_critSec);
		m_cbfunc = NULL;
        m_devid = 0;
        m_strmidx = 0;
        m_last_size = 0;
        m_bOn = TRUE;
    };
    ~CCallback(void) 
    { 
        try {
            CloseHandle(m_hFrameEvent);
            m_hFrameEvent = NULL;
            DeleteCriticalSection(&m_critSec);
        } catch (...) {
    
        }
    
    };
//    CSampleGrabberCB callback;

    HRESULT  STDMETHODCALLTYPE QueryInterface ( 
        /* [in] */ REFIID riid,
        /* [iid_is][out] */ void **ppvObject);

        ULONG STDMETHODCALLTYPE AddRef( void);

    ULONG STDMETHODCALLTYPE Release( void );

    HRESULT STDMETHODCALLTYPE SampleCB( 
        double SampleTime,
        IMediaSample *pSample);

    HRESULT STDMETHODCALLTYPE BufferCB( 
        double SampleTime,
        BYTE *pBuffer,
        long BufferLen);
    void SetCallback( cbfunc_t func) { m_cbfunc = func;};
    void SetDevice(int devid, int strmidx) { m_devid = devid; m_strmidx = strmidx;};
private:
    cbfunc_t m_cbfunc;
    int m_devid;
    int m_strmidx;

};

