// Registry functions


// see 811 advanced settings document
#define ADVANCED_FLAGS_NOAVSYNC 0x0001
static int GetAdvanced()
{
    CString keyname;
    DWORD val = 0;
    DWORD size = sizeof( DWORD);
    HRESULT hrloc2 = -1;
    HKEY hk;
    DWORD type = REG_DWORD;
    keyname = "SOFTWARE\\Sensoray\\811";

    if( !FAILED(hrloc2 = RegOpenKeyEx(HKEY_LOCAL_MACHINE, keyname.GetBuffer(), 0, KEY_QUERY_VALUE, &hk)))
    {
        keyname = "AdvancedFlags";
        hrloc2 = RegQueryValueEx(hk, keyname, NULL, &type,(LPBYTE)  &val, &size);
    }
    if( !FAILED(hrloc2))
    {
        if( val )
        {
            return val;
        }
        else return 0;
    }
    return 0;
}


static int GetRenderer()
{
    CString keyname;
    DWORD val = 0;
    DWORD size = sizeof( DWORD);
    HRESULT hrloc2 = -1;
    HKEY hk;
    DWORD type = REG_DWORD;
    keyname = "SOFTWARE\\Sensoray\\811";

    if( !FAILED(hrloc2 = RegOpenKeyEx(HKEY_LOCAL_MACHINE, keyname.GetBuffer(), 0, KEY_QUERY_VALUE, &hk)))
    {
        keyname = "Renderer";
        hrloc2 = RegQueryValueEx(hk, keyname, NULL, &type,(LPBYTE)  &val, &size);
    }
    if( !FAILED(hrloc2))
    {
        if( val )
        {
            return val;
        }
        else return 0;
    }
    return 0;
}

// see 811 advanced settings document
#define SH_MPEG  0 // snapshots from MPEG stream
#define SH_RAW   1 // snapshots from RAW stream
#define SH_NONE  2 // snapshots disabled

static int GetSnapshotMethod()
{
    CString keyname;
    DWORD val = 0;
    DWORD size = sizeof( DWORD);
    HRESULT hrloc2 = -1;
    HKEY hk;
    DWORD type = REG_DWORD;
    keyname = "SOFTWARE\\Sensoray\\811";

    if( !FAILED(hrloc2 = RegOpenKeyEx(HKEY_LOCAL_MACHINE, keyname.GetBuffer(), 0, KEY_QUERY_VALUE, &hk)))
    {
        keyname = "SnapshotMethod";
        hrloc2 = RegQueryValueEx(hk, keyname, NULL, &type,(LPBYTE)  &val, &size);
    }
    if( !FAILED(hrloc2))
    {
        if( val )
        {
            return val;
        }
        else return 1;
    }
    return 1;
}


static BOOL GetAviDecomp()
{
    CString keyname;
    DWORD val = 0;
    DWORD size = sizeof( DWORD);
    HRESULT hrloc2 = -1;
    HKEY hk;
    DWORD type = REG_DWORD;
    keyname = "SOFTWARE\\Sensoray\\811";

    if( !FAILED(hrloc2 = RegOpenKeyEx(HKEY_LOCAL_MACHINE, keyname.GetBuffer(), 0, KEY_QUERY_VALUE, &hk)))
    {
        keyname = "AviDecomp";
        hrloc2 = RegQueryValueEx(hk, keyname, NULL, &type,(LPBYTE)  &val, &size);
    }
    if( !FAILED(hrloc2))
    {
        if( val )
        {
            return TRUE;
        }
        else return FALSE;
    }
    return FALSE;
}



#define RENDERER_DEFAULT    0x0000
#define RENDERER_VMR9       0x0001
#define RENDERER_VMR7       0x0002
#define RENDERER_OLD        0x0003

#define AVI_DECOMP_CLSID "{CF49D4E0-1115-11CE-B03A-0020AF0BA770}"


static int GetTestFlags()
{
    CString keyname;
    DWORD val = 0;
    DWORD size = sizeof( DWORD);
    HRESULT hrloc2 = -1;
    HKEY hk;
    DWORD type = REG_DWORD;
    keyname = "SOFTWARE\\Sensoray\\811";

    if( !FAILED(hrloc2 = RegOpenKeyEx(HKEY_LOCAL_MACHINE, keyname.GetBuffer(), 0, KEY_QUERY_VALUE, &hk)))
    {
        keyname = "TestFlags";
        hrloc2 = RegQueryValueEx(hk, keyname, NULL, &type,(LPBYTE)  &val, &size);
    }
    if( !FAILED(hrloc2))
    {
        return val;
    }
    else return 0;
}


#define TEST_FLAGS_NOAUDIO      0x0001
#define TEST_FLAGS_NOAVSYNC     0x0002
#define TEST_FLAGS_NOAUDIONULL  0x0004
#define TEST_FLAGS_NOMUXER      0x0008
#define TEST_FLAGS_NOSNAP       0x0010
#define TEST_FLAGS_RAWNULL      0x0020
#define TEST_FLAGS_SG1          0x0040
#define TEST_FLAGS_SG2          0x0080
#define TEST_FLAGS_2250METHOD   0x0100


// returns -2 on fail, otherwise returns clock source to use
// return -1 == use nref =-1
// return 4 == USE default algorigthm for choosing clock
static int GetClockSource()
{
    CString keyname;
    DWORD val = 0;
    DWORD size = sizeof( DWORD);
    HRESULT hrloc2 = -1;
    HKEY hk;
    DWORD type = REG_DWORD;
    keyname = "SOFTWARE\\Sensoray\\811";

    if( !FAILED(hrloc2 = RegOpenKeyEx(HKEY_LOCAL_MACHINE, keyname.GetBuffer(), 0, KEY_QUERY_VALUE, &hk)))
    {
        keyname = "DSHOWClock";
        hrloc2 = RegQueryValueEx(hk, keyname, NULL, &type,(LPBYTE)  &val, &size);
    }

    if( hrloc2 == S_OK)
    {
        if( val <4)
            return val;
        if( val == 4)
            return -1;
        if( val == 5)
            return 4;
        return -2;
    }
    return -2;
}
