#ifndef _SAMPLEGRABBER_H_
#define _SAMPLEGRABBER_H_

/*lint -e539*/
/*lint -e525*/
/*lint -e1762*/
/*lint -e715*/
/*lint -e830*/
/*lint -e1510*/
/*lint -e713*/
/*lint -e732*/ // loss sign

// Need to include qedit.h to get definitions for ISampleGrabber and ISampleGrabberCB
// But qedit.h includes d3d.h (when we are using d3d9.h)
// So, copy the qedit.h ISampleGrabber definitions here instead.
//#include <qedit.h> // For ISampleGrabber
//#include "ovlgen/ovlgen/ovlgen.h" // for OVLREGIONS def

#define OVLREGIONS 8

#ifndef __ISampleGrabberCB_FWD_DEFINED__
#define __ISampleGrabberCB_FWD_DEFINED__
typedef interface ISampleGrabberCB ISampleGrabberCB;
#endif 	/* __ISampleGrabberCB_FWD_DEFINED__ */


#ifndef __ISampleGrabber_FWD_DEFINED__
#define __ISampleGrabber_FWD_DEFINED__
typedef interface ISampleGrabber ISampleGrabber;
#endif 	/* __ISampleGrabber_FWD_DEFINED__ */

#ifndef __SampleGrabber_FWD_DEFINED__
#define __SampleGrabber_FWD_DEFINED__
#ifdef __cplusplus
typedef class SampleGrabber SampleGrabber;
#else
typedef struct SampleGrabber SampleGrabber;
#endif /* __cplusplus */
#endif 	/* __SampleGrabber_FWD_DEFINED__ */

#ifndef __ISampleGrabberCB_INTERFACE_DEFINED__
#define __ISampleGrabberCB_INTERFACE_DEFINED__

/* interface ISampleGrabberCB */
/* [unique][helpstring][local][uuid][object] */ 


EXTERN_C const IID IID_ISampleGrabberCB;

#if defined(__cplusplus) && !defined(CINTERFACE)
    
    MIDL_INTERFACE("0579154A-2B53-4994-B0D0-E778118EFF85")
    ISampleGrabberCB : public IUnknown
    {
    public:
        virtual HRESULT STDMETHODCALLTYPE SampleCB( 
            double SampleTime,
            IMediaSample *pSample) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE BufferCB( 
            double SampleTime,
            BYTE *pBuffer,
            long BufferLen) = 0;
        
    };
    
#else 	/* C style interface */

    typedef struct ISampleGrabberCBVtbl
    {
        BEGIN_INTERFACE
        
        HRESULT ( STDMETHODCALLTYPE *QueryInterface )( 
            ISampleGrabberCB * This,
            /* [in] */ REFIID riid,
            /* [iid_is][out] */ void **ppvObject);
        
        ULONG ( STDMETHODCALLTYPE *AddRef )( 
            ISampleGrabberCB * This);
        
        ULONG ( STDMETHODCALLTYPE *Release )( 
            ISampleGrabberCB * This);
        
        HRESULT ( STDMETHODCALLTYPE *SampleCB )( 
            ISampleGrabberCB * This,
            double SampleTime,
            IMediaSample *pSample);
        
        HRESULT ( STDMETHODCALLTYPE *BufferCB )( 
            ISampleGrabberCB * This,
            double SampleTime,
            BYTE *pBuffer,
            long BufferLen);
        
        END_INTERFACE
    } ISampleGrabberCBVtbl;

    interface ISampleGrabberCB
    {
        CONST_VTBL struct ISampleGrabberCBVtbl *lpVtbl;
    };

    

#ifdef COBJMACROS


#define ISampleGrabberCB_QueryInterface(This,riid,ppvObject)	\
    (This)->lpVtbl -> QueryInterface(This,riid,ppvObject)

#define ISampleGrabberCB_AddRef(This)	\
    (This)->lpVtbl -> AddRef(This)

#define ISampleGrabberCB_Release(This)	\
    (This)->lpVtbl -> Release(This)


#define ISampleGrabberCB_SampleCB(This,SampleTime,pSample)	\
    (This)->lpVtbl -> SampleCB(This,SampleTime,pSample)

#define ISampleGrabberCB_BufferCB(This,SampleTime,pBuffer,BufferLen)	\
    (This)->lpVtbl -> BufferCB(This,SampleTime,pBuffer,BufferLen)

#endif /* COBJMACROS */


#endif 	/* C style interface */



HRESULT STDMETHODCALLTYPE ISampleGrabberCB_SampleCB_Proxy( 
    ISampleGrabberCB * This,
    double SampleTime,
    IMediaSample *pSample);


void __RPC_STUB ISampleGrabberCB_SampleCB_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE ISampleGrabberCB_BufferCB_Proxy( 
    ISampleGrabberCB * This,
    double SampleTime,
    BYTE *pBuffer,
    long BufferLen);


void __RPC_STUB ISampleGrabberCB_BufferCB_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);



#endif 	/* __ISampleGrabberCB_INTERFACE_DEFINED__ */


#ifndef __ISampleGrabber_INTERFACE_DEFINED__
#define __ISampleGrabber_INTERFACE_DEFINED__

/* interface ISampleGrabber */
/* [unique][helpstring][local][uuid][object] */ 


EXTERN_C const IID IID_ISampleGrabber;

#if defined(__cplusplus) && !defined(CINTERFACE)
    
    MIDL_INTERFACE("6B652FFF-11FE-4fce-92AD-0266B5D7C78F")
    ISampleGrabber : public IUnknown
    {
    public:
        virtual HRESULT STDMETHODCALLTYPE SetOneShot( 
            BOOL OneShot) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SetMediaType( 
            const AM_MEDIA_TYPE *pType) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetConnectedMediaType( 
            AM_MEDIA_TYPE *pType) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SetBufferSamples( 
            BOOL BufferThem) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetCurrentBuffer( 
            /* [out][in] */ long *pBufferSize,
            /* [out] */ long *pBuffer) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetCurrentSample( 
            /* [retval][out] */ IMediaSample **ppSample) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE SetCallback( 
            ISampleGrabberCB *pCallback,
            long WhichMethodToCallback) = 0;
        
    };
    
#else 	/* C style interface */

    typedef struct ISampleGrabberVtbl
    {
        BEGIN_INTERFACE
        
        HRESULT ( STDMETHODCALLTYPE *QueryInterface )( 
            ISampleGrabber * This,
            /* [in] */ REFIID riid,
            /* [iid_is][out] */ void **ppvObject);
        
        ULONG ( STDMETHODCALLTYPE *AddRef )( 
            ISampleGrabber * This);
        
        ULONG ( STDMETHODCALLTYPE *Release )( 
            ISampleGrabber * This);
        
        HRESULT ( STDMETHODCALLTYPE *SetOneShot )( 
            ISampleGrabber * This,
            BOOL OneShot);
        
        HRESULT ( STDMETHODCALLTYPE *SetMediaType )( 
            ISampleGrabber * This,
            const AM_MEDIA_TYPE *pType);
        
        HRESULT ( STDMETHODCALLTYPE *GetConnectedMediaType )( 
            ISampleGrabber * This,
            AM_MEDIA_TYPE *pType);
        
        HRESULT ( STDMETHODCALLTYPE *SetBufferSamples )( 
            ISampleGrabber * This,
            BOOL BufferThem);
        
        HRESULT ( STDMETHODCALLTYPE *GetCurrentBuffer )( 
            ISampleGrabber * This,
            /* [out][in] */ long *pBufferSize,
            /* [out] */ long *pBuffer);
        
        HRESULT ( STDMETHODCALLTYPE *GetCurrentSample )( 
            ISampleGrabber * This,
            /* [retval][out] */ IMediaSample **ppSample);
        
        HRESULT ( STDMETHODCALLTYPE *SetCallback )( 
            ISampleGrabber * This,
            ISampleGrabberCB *pCallback,
            long WhichMethodToCallback);
        
        END_INTERFACE
    } ISampleGrabberVtbl;

    interface ISampleGrabber
    {
        CONST_VTBL struct ISampleGrabberVtbl *lpVtbl;
    };

    

#ifdef COBJMACROS


#define ISampleGrabber_QueryInterface(This,riid,ppvObject)	\
    (This)->lpVtbl -> QueryInterface(This,riid,ppvObject)

#define ISampleGrabber_AddRef(This)	\
    (This)->lpVtbl -> AddRef(This)

#define ISampleGrabber_Release(This)	\
    (This)->lpVtbl -> Release(This)


#define ISampleGrabber_SetOneShot(This,OneShot)	\
    (This)->lpVtbl -> SetOneShot(This,OneShot)

#define ISampleGrabber_SetMediaType(This,pType)	\
    (This)->lpVtbl -> SetMediaType(This,pType)

#define ISampleGrabber_GetConnectedMediaType(This,pType)	\
    (This)->lpVtbl -> GetConnectedMediaType(This,pType)

#define ISampleGrabber_SetBufferSamples(This,BufferThem)	\
    (This)->lpVtbl -> SetBufferSamples(This,BufferThem)

#define ISampleGrabber_GetCurrentBuffer(This,pBufferSize,pBuffer)	\
    (This)->lpVtbl -> GetCurrentBuffer(This,pBufferSize,pBuffer)

#define ISampleGrabber_GetCurrentSample(This,ppSample)	\
    (This)->lpVtbl -> GetCurrentSample(This,ppSample)

#define ISampleGrabber_SetCallback(This,pCallback,WhichMethodToCallback)	\
    (This)->lpVtbl -> SetCallback(This,pCallback,WhichMethodToCallback)

#endif /* COBJMACROS */


#endif 	/* C style interface */



HRESULT STDMETHODCALLTYPE ISampleGrabber_SetOneShot_Proxy( 
    ISampleGrabber * This,
    BOOL OneShot);


void __RPC_STUB ISampleGrabber_SetOneShot_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE ISampleGrabber_SetMediaType_Proxy( 
    ISampleGrabber * This,
    const AM_MEDIA_TYPE *pType);


void __RPC_STUB ISampleGrabber_SetMediaType_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE ISampleGrabber_GetConnectedMediaType_Proxy( 
    ISampleGrabber * This,
    AM_MEDIA_TYPE *pType);


void __RPC_STUB ISampleGrabber_GetConnectedMediaType_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE ISampleGrabber_SetBufferSamples_Proxy( 
    ISampleGrabber * This,
    BOOL BufferThem);


void __RPC_STUB ISampleGrabber_SetBufferSamples_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE ISampleGrabber_GetCurrentBuffer_Proxy( 
    ISampleGrabber * This,
    /* [out][in] */ long *pBufferSize,
    /* [out] */ long *pBuffer);


void __RPC_STUB ISampleGrabber_GetCurrentBuffer_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE ISampleGrabber_GetCurrentSample_Proxy( 
    ISampleGrabber * This,
    /* [retval][out] */ IMediaSample **ppSample);


void __RPC_STUB ISampleGrabber_GetCurrentSample_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);


HRESULT STDMETHODCALLTYPE ISampleGrabber_SetCallback_Proxy( 
    ISampleGrabber * This,
    ISampleGrabberCB *pCallback,
    long WhichMethodToCallback);


void __RPC_STUB ISampleGrabber_SetCallback_Stub(
    IRpcStubBuffer *This,
    IRpcChannelBuffer *_pRpcChannelBuffer,
    PRPC_MESSAGE _pRpcMessage,
    DWORD *_pdwStubPhase);

#endif 	/* __ISampleGrabber_INTERFACE_DEFINED__ */


EXTERN_C const CLSID CLSID_SampleGrabber;

#ifdef __cplusplus

class DECLSPEC_UUID("C1F400A0-3F08-11d3-9F0B-006008039E37")
SampleGrabber;
#endif


#define COLOR_DEPTH_RGB24 24
#define BYTES_PER_PIXEL24 (((int)(COLOR_DEPTH_RGB24) + 7) / 8) // = 3

//////////////////////////////////////////////////////////////////////////
// Implementation of CSampleGrabberCB object
//
// Note: this object is a SEMI-COM object, and can only be created statically.
//////////////////////////////////////////////////////////////////////////
class CSampleGrabberCB : public ISampleGrabberCB 
{

protected:

    // These will get set by the main thread below. We need to
    // know this in order to write out the bmp
    HANDLE m_hOvlMutex; //handle to mutex to control access to the overlay memory
    long   m_Width;                  // Width of video Frame
    long   m_Height;                 // Height of video Frame
    BYTE  *m_OvlPtr[OVLREGIONS];     // pointer to RGB bytes defining overlay
    int    m_OvlWidth[OVLREGIONS];   // image Width
    int    m_OvlHeight[OVLREGIONS];  // image Height
    int    m_OvlOffset[OVLREGIONS];  // Byte offset into video frame
    int    m_OvlFlip[OVLREGIONS];    // Used to calc m_OvlOffset on change of m_Width/m_Height
    int    m_OvlLeft[OVLREGIONS];    // Used to calc m_OvlOffset on change of m_Width/m_Height
    int    m_OvlTop[OVLREGIONS];     // Used to calc m_OvlOffset on change of m_Width/m_Height
    BYTE  *m_Pause;                  // Used to copy to output buffer to 'pause' preview
                                     // while letting record continue.

public:

    CSampleGrabberCB()
    {
        int ii;
        for (ii=0; ii<OVLREGIONS ; ii++) {
            m_OvlPtr[ii]    = 0;  // pointer to RGB bytes defining overlay
            m_OvlWidth[ii]  = 0;  // image Width
            m_OvlHeight[ii] = 0;  // image Height
            m_OvlOffset[ii] = 0;  // Byte offset into video frame
            m_OvlFlip[ii]   = 0;  // Used to calc m_OvlOffset on change of m_Width/m_Height
            m_OvlLeft[ii]   = 0;  // Used to calc m_OvlOffset on change of m_Width/m_Height
            m_OvlTop[ii]    = 0;  // Used to calc m_OvlOffset on change of m_Width/m_Height
        }

        m_Pause = 0;
        
        // Create a mutex with no initial owner to handel changing overlays
        m_hOvlMutex = CreateMutex( 
            NULL,                       // no security attributes
            FALSE,                      // initially not owned
            _T("")); //"MutexToProtectOverlay");   // name of mutex
        // NOTE: Use the CloseHandle function to close the handle, however the 
        // system closes the handle automatically when the process terminates. 
        // The mutex object is destroyed when its last handle has been closed.
        m_Width = 0;
        m_Height = 0;
    }

    ~CSampleGrabberCB()
    {
        int ii;
        for (ii=0; ii<OVLREGIONS ; ii++) {
            if ( m_OvlPtr[ii] ) {
                free( m_OvlPtr[ii] );
                m_OvlPtr[ii] = 0;
            }
        }
        if (m_hOvlMutex != NULL)
        {
            CloseHandle(m_hOvlMutex);
            m_hOvlMutex = NULL;
        }
        m_Pause = 0;
    }

    void Zero()
    {
        int ii;
        m_Width  = 0;
        m_Height = 0;
        for (ii=0; ii<OVLREGIONS ; ii++) {
            if ( m_OvlPtr[ii] ) {
                free( m_OvlPtr[ii] );
                m_OvlPtr[ii] = 0;
            }
            m_OvlWidth[ii]  = 0;  // image Width
            m_OvlHeight[ii] = 0;  // image Height
            m_OvlOffset[ii] = 0;  // Byte offset into video frame
            m_OvlFlip[ii]   = 0;  // Used to calc m_OvlOffset on change of m_Width/m_Height
            m_OvlLeft[ii]   = 0;  // Used to calc m_OvlOffset on change of m_Width/m_Height
            m_OvlTop[ii]    = 0;  // Used to calc m_OvlOffset on change of m_Width/m_Height
        }
        m_Pause = 0;
    }
    
    // Fake out any COM ref counting
    //
    STDMETHODIMP_(ULONG) AddRef() { return 2; }
    STDMETHODIMP_(ULONG) Release() { return 1; }

    // Fake out any COM QI'ing
    //
    STDMETHODIMP QueryInterface(REFIID riid, void ** ppv)
    {
        //CheckPointer(ppv,E_POINTER);
        if( ppv == NULL) 
            return E_POINTER;
        
        if( riid == IID_ISampleGrabberCB || riid == IID_IUnknown ) 
        {
            *ppv = (void *) static_cast<ISampleGrabberCB*> ( this );
            return NOERROR;
        }    

        return E_NOINTERFACE;
    }

    void DoOverlay( BYTE * pBuffer, long Size )
    {
        int   region,x,y;
        BYTE *sptr, *dptr, *dline;
        DWORD dwWaitResult; 

        // Make sure overlay generator isn't deleting overlay's
        dwWaitResult = WaitForSingleObject(m_hOvlMutex, 0);
        if (dwWaitResult == WAIT_OBJECT_0) {
            // This thread got mutex ownership
            if (m_Pause) {
                memcpy(pBuffer, m_Pause, Size);
            } else {
                for (region=0; region<OVLREGIONS ; region++) {
		        	if (m_OvlPtr[region] != 0) {
                        sptr  = (BYTE *)m_OvlPtr[region];    // pointer to RGB bytes defining overlay
                        dptr  = pBuffer + m_OvlOffset[region]; // offset into video frame
                        //dptr  = pBuffer;
                        dline = dptr;
                        for (y=0 ; y < m_OvlHeight[region] ; y++) {
                            for (x=0 ; x < m_OvlWidth[region] ; x+=3) {
                                if ((*(sptr+0) == 0) && (*(sptr+1) == 0) && (*(sptr+2) == 0)) {
                                    // Transparent
                                    sptr = sptr + 3; // Next pix
                                    dptr = dptr + 3; // Next pix
                                } else {
                                    //    Red            Green              Blue
                                    *dptr++=*sptr++; *dptr++=*sptr++;  *dptr++=*sptr++;
                                }
                            }
                            dptr  = dline + (3*m_Width); // Next Line
                            dline = dptr;
                        }
		        	}
                }
            } // Pause
            ReleaseMutex(m_hOvlMutex);
        }
        // else don't do any overlays while they are being updated
        // Cannot get mutex ownership due to time-out or 
        // Got ownership of the abandoned mutex object
        // (i.e. don't call ReleaseMutex)
    }

    // We don't implement this one
    //
    STDMETHODIMP SampleCB( double SampleTime, IMediaSample * pSample )
    {
        //HRESULT hr = 0;
        //BYTE   *pBuffer;
        //long    cSize;
        //hr    = pSample->GetPointer(&pBuffer);
        //cSize = pSample->GetSize();
        //if (hr==S_OK)
        //    DoOverlay( pBuffer, cSize );
        //return S_OK;
        return 0;
    }

    // The sample grabber is calling us back on its deliver thread.
    // This is NOT the main app thread!
    //
    STDMETHODIMP BufferCB( double SampleTime, BYTE * pBuffer, long BufferSize )
    {
        //_tprintf(TEXT("Found a sample at time %ld ms\r\n"), 
        //         long( SampleTime * 1000 ) );

        DoOverlay( (BYTE *)pBuffer, BufferSize );
        return S_OK;
    }

    // Calculate Offset into frame, depending on whether it has been flipped or not
    int CalcOffset(int OvlTop, int OvlLeft, int OvlHeight, int flip)
    {
        if (flip != 0) {
            return ( ((m_Height-1) - OvlTop - OvlHeight) * m_Width * BYTES_PER_PIXEL24 +
                     (OvlLeft * BYTES_PER_PIXEL24) );
    	} else { // Normal 0 = top
            return (  OvlTop  * m_Width +
                     (OvlLeft * BYTES_PER_PIXEL24) );
        }
    }

    /*-----------------------------------------------------------------------------
    |   Function:   CSampleGrabberCB::SetOverlay
    |   Purpose:    Update Overlay memory under protection of a mutex
    |   Arguments:  Region : one of OVLREGIONS different overlays to be applied 
    |               flip   : whether to flip the location offsets
    |               OvlPos : left/top = start location. right/bottom = width/height
    |               OvlPtr : pointer to memory containing overlay
    |               Size   : number of bytes in OvlPtr
    |   Returns:    0 fail, -1 success 
    |   Notes:      Mutex needed so memory is not released while DoOverlay is using it
    \----------------------------------------------------------------------------*/
    int SetOverlay(int Region, int flip, RECT OvlPos, BYTE *OvlPtr, int Size)
    {
        DWORD dwWaitResult;
        int   new_Width;
        int   new_Height;
        int   new_Offset;
        BYTE *new_OvlPtr;
        BYTE *old_OvlPtr=NULL;

    	if ( Region < 0 || Region >= OVLREGIONS )
    		return 0;

        new_Width  = OvlPos.right * BYTES_PER_PIXEL24;  // image Width
        new_Height = OvlPos.bottom;                     // image Height
        
        if (new_Width*new_Height != Size)
           return 0;
    
        if (Size != 0) {
            new_OvlPtr = (BYTE *)malloc( Size );
            if (! new_OvlPtr)
                return(0);
            memcpy(new_OvlPtr, OvlPtr, Size);

            new_Offset = CalcOffset(OvlPos.top, OvlPos.left, OvlPos.bottom, flip);

        } else {
            new_OvlPtr = 0;
            new_Offset = 0;
        }

        // Wait for overlay routine to finish using overlay memory
        if (m_hOvlMutex) {
            dwWaitResult = WaitForSingleObject(m_hOvlMutex, 5000L); // 5 sec
            if (dwWaitResult == WAIT_OBJECT_0) {
                // Recieved ownership:
                // go ahead and mess with overlay memory

                old_OvlPtr          = m_OvlPtr[Region]; // Save so it can be released later
                m_OvlPtr[Region]    = new_OvlPtr; // bitmap already flipped if needed
                m_OvlWidth[Region]  = new_Width;
                m_OvlHeight[Region] = new_Height;
                m_OvlOffset[Region] = new_Offset;
                m_OvlFlip[Region]   = flip;        // Used to calc m_OvlOffset on change of m_Width/m_Height
                m_OvlLeft[Region]   = OvlPos.left; // Used to calc m_OvlOffset on change of m_Width/m_Height
                m_OvlTop[Region]    = OvlPos.top;  // Used to calc m_OvlOffset on change of m_Width/m_Height

                ReleaseMutex(m_hOvlMutex);
            } else {
                if (new_OvlPtr)
                    free(new_OvlPtr);
                return 0; // Error: WAIT_TIMEOUT or WAIT_ABANDONED
            }
        } else { // No Mutex: just do it
                old_OvlPtr          = m_OvlPtr[Region]; // Save so it can be released later
                m_OvlPtr[Region]    = new_OvlPtr; // bitmap already flipped if needed
                m_OvlWidth[Region]  = new_Width;
                m_OvlHeight[Region] = new_Height;
                m_OvlOffset[Region] = new_Offset;
                m_OvlFlip[Region]   = flip;        // Used to calc m_OvlOffset on change of m_Width/m_Height
                m_OvlLeft[Region]   = OvlPos.left; // Used to calc m_OvlOffset on change of m_Width/m_Height
                m_OvlTop[Region]    = OvlPos.top;  // Used to calc m_OvlOffset on change of m_Width/m_Height
        }

        if ( old_OvlPtr ) {
            free( old_OvlPtr );
        }

        return(-1);
    }
    
    /*-----------------------------------------------------------------------------
    |   Function:   CSampleGrabberCB::DoOverlayOnBuf
    |   Purpose:    Use video overlay routine to overlay a frame in memory
    |   Arguments:  pBuffer to be updated
    |   Returns:    
    |   Notes:      
    \----------------------------------------------------------------------------*/
    void DoOverlayOnBuf(BYTE *pBuffer)
    {
        DoOverlay( pBuffer, 0 );
    }

    /*-----------------------------------------------------------------------------
    |   Function:   CSampleGrabberCB::SetFrameWidth
    |   Purpose:    Set video frames width and recalc other param if needed
    |   Arguments:  NewFrameWidth is new width of video frame
    |   Returns:    0 on error, -1 otherwise
    |   Notes:      
    \----------------------------------------------------------------------------*/
    int SetFrameWidth(int NewFrameWidth)
    {
        return( ReCalc(NewFrameWidth, m_Height) );
    }

    /*-----------------------------------------------------------------------------
    |   Function:   CSampleGrabberCB::SetFrameHeight
    |   Purpose:    Set video frames width and recalc other param if needed
    |   Arguments:  NewFrameHeight is new height of video frame
    |   Returns:    0 on error, -1 otherwise
    |   Notes:      
    \----------------------------------------------------------------------------*/
    int SetFrameHeight(int NewFrameHeight)
    {
        return( ReCalc(m_Width, NewFrameHeight) );
    }

    /*-----------------------------------------------------------------------------
    |   Function:   CSampleGrabberCB::ReCalc
    |   Purpose:    Set video frame's height and width and recalc the overlay offset
    |   Arguments:  NewFrameWidth is new width of video frame
    |               NewFrameHeight is new height of video frame
    |   Returns:    0 on error, -1 otherwise
    |   Notes:      
    \----------------------------------------------------------------------------*/
    int ReCalc(int NewFrameWidth, int NewFrameHeight)
    {
        DWORD dwWaitResult;
        int   ii;

        // Wait for overlay routine to finish using overlay memory
        if (m_hOvlMutex) {
            dwWaitResult = WaitForSingleObject(m_hOvlMutex, 5000L); // 5 sec
            if (dwWaitResult == WAIT_OBJECT_0) {
                // Recieved ownership:
                // go ahead and mess with overlay memory
                m_Width  = NewFrameWidth;
                m_Height = NewFrameHeight;
                for (ii=0; ii<OVLREGIONS ; ii++) {
                    m_OvlOffset[ii] = CalcOffset(m_OvlTop[ii], m_OvlLeft[ii], m_OvlHeight[ii], m_OvlFlip[ii]);
                    // All other parameters stay the same
                } // for all overlays

                ReleaseMutex(m_hOvlMutex);
            } else {
                return 0; // Error: WAIT_TIMEOUT or WAIT_ABANDONED
            }
        } else { // No Mutex: just do it
            m_Width  = NewFrameWidth;
            m_Height = NewFrameHeight;
            for (ii=0; ii<OVLREGIONS ; ii++) {
                m_OvlOffset[ii] = CalcOffset(m_OvlTop[ii], m_OvlLeft[ii], m_OvlHeight[ii], m_OvlFlip[ii]);
                // All other parameters stay the same
            } // for all overlays
        } // Mutex
        return(-1);
    } // SetFrameHeight

    /*-----------------------------------------------------------------------------
    |   Function:   CSampleGrabberCB::SetPauseBuf
    |   Purpose:    Pause video frames by displaying given frame continually
    |   Arguments:  FramePtr point's to frame to be displayed. Set to 0 to disable
    |   Returns:    
    |   Notes:      
    \----------------------------------------------------------------------------*/
    void SetPauseBuf(BYTE *FramePtr)
    {
        m_Pause = FramePtr;
    }

}; // Class CSampleGrabberCB

#endif // _SAMPLEGRABBER_H_
