#if !defined DSHOWHELPER_H
#define DSHOWHELPER_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "interfaces.h"

#define E_DEVICE_NOT_READY 0xB0004001L

#define ADDFILTER_NEW(strClsid,filterregname,proxyname) \
   { CLSID clsid; \
    CLSIDFromString( CString(strClsid).AllocSysString(), &clsid); \
    hr = proxyname.CreateInstance( clsid); \
    hr = m_pGB->AddFilter( proxyname, CString(filterregname).AllocSysString());\
   }

#define CONNECT_NEW(p1,p2,msg) \
{\
    hr = m_pGB->Connect(p1,p2);\
}

#define CONNECT_MT(p1,p2,mt) \
{\
    hr = m_pGB->ConnectDirect(p1,p2,mt);\
}


class CDShowHelper  
{
public:
    static HRESULT FindNumDevices( REFCLSID clsidCategory,CString strName, int *numDevices, IGraphBuilderPtr pGB);
	static HRESULT ShowFilterSettings(CString strFilterName,HWND hwnd, IGraphBuilderPtr pGB);
#ifdef DEBUG    
    static void DumpGraph( IGraphBuilderPtr pGB );
#endif
    static HRESULT AddFilterDmo( CString strClsid, CString strName, IBaseFilter **ppFilter, IGraphBuilderPtr pGB);
    static HRESULT SetSyncClockGB(IGraphBuilderPtr pGB, int RefClock);
    static IPinPtr FindPin(BOOL bInput, IBaseFilterPtr pFilter);
    static IPinPtr FindPin(CString strName, IBaseFilterPtr pFilter);
    static IPinPtr FirstDisconnectedPin(BOOL bInput, IBaseFilterPtr pFilter);
    static IBaseFilterPtr FindFilter(CString strName, IGraphBuilderPtr pGB);
    static HRESULT AddCategoryFilter(REFCLSID clsidCategory,CString strName,IGraphBuilderPtr pGB, IBaseFilter** ppFilter, int instance) ;
};

#endif
